Debian Bug report logs - #374797
libpopt-dev: wrong libdir setting for amd64, causing rpath usage in dependent packages.

version graph

Package: libpopt-dev; Maintainer for libpopt-dev is Paul Martin <pm@debian.org>; Source for libpopt-dev is src:popt.

Reported by: Neil Williams <linux@codehelp.co.uk>

Date: Wed, 21 Jun 2006 10:48:09 UTC

Severity: important

Found in version popt/1.10-2

Fixed in version popt/1.10-3

Done: Paul Martin <pm@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Paul Martin <pm@debian.org>:
Bug#374797; Package libpopt-dev. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <linux@codehelp.co.uk>:
New Bug report received and forwarded. Copy sent to Paul Martin <pm@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Neil Williams <linux@codehelp.co.uk>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: livpopt-dev: wrong libdir setting for amd64, causing rpath usage in dependent packages.
Date: Wed, 21 Jun 2006 11:33:36 +0100
Package: libpopt-dev
Version: 1.10-2
Severity: important

This reflects an earlier bug in libffi3:  #268152 - libpopt-dev includes
libpopt.la which refers to /usr/lib64 on amd64. This non-standard
directory then causes packages built against libpopt-dev on amd64 to
refer to /usr/lib64 via libtool and generate spurious --rpath usage.
Packages built this way then generate lintian and linda errors related
to --rpath usage in the resulting binaries. 

Packages built on the same system but which do not use popt have no
lintian or linda errors.

Packages built on other architectures (like powerpc and i386) using popt
generate no linda or lintian errors.

$ grep lib64 /usr/lib/*.la
... /usr/lib64/libpopt.la ...

$ grep lib64 /usr/lib/libpopt.la
libdir='/usr/lib64'


-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: amd64 (x86_64)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.16-1-amd64-k8
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)

Versions of packages libpopt-dev depends on:
ii  libc6-dev [libc-dev]          2.3.6-15   GNU C Library: Development Librari
ii  libpopt0                      1.10-2     lib for parsing cmdline parameters

libpopt-dev recommends no packages.

-- no debconf information



Changed Bug title. Request was from Neil Williams <linux@codehelp.co.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#374797; Package libpopt-dev. Full text and rfc822 format available.

Acknowledgement sent to Paul Martin <pm@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #12 received at 374797@bugs.debian.org (full text, mbox):

From: Paul Martin <pm@debian.org>
To: Neil Williams <linux@codehelp.co.uk>, 374797@bugs.debian.org
Subject: Re: Bug#374797: livpopt-dev: wrong libdir setting for amd64, causing rpath usage in dependent packages.
Date: Wed, 21 Jun 2006 19:04:13 +0100
On Wed, Jun 21, 2006 at 11:33:36AM +0100, Neil Williams wrote:
> Package: libpopt-dev
> Version: 1.10-2
> Severity: important
> 
> This reflects an earlier bug in libffi3:  #268152 - libpopt-dev includes
> libpopt.la which refers to /usr/lib64 on amd64. This non-standard
> directory then causes packages built against libpopt-dev on amd64 to
> refer to /usr/lib64 via libtool and generate spurious --rpath usage.
> Packages built this way then generate lintian and linda errors related
> to --rpath usage in the resulting binaries. 

You can blame [expletive] autoconf for this one. Libraries built using 
that prefer to use lib64 as the name of the libdir.

-- 
Paul Martin <pm@debian.org>



Information forwarded to debian-bugs-dist@lists.debian.org, Paul Martin <pm@debian.org>:
Bug#374797; Package libpopt-dev. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <linux@codehelp.co.uk>:
Extra info received and forwarded to list. Copy sent to Paul Martin <pm@debian.org>. Full text and rfc822 format available.

Message #17 received at 374797@bugs.debian.org (full text, mbox):

From: Neil Williams <linux@codehelp.co.uk>
To: Paul Martin <pm@debian.org>
Cc: 374797@bugs.debian.org
Subject: Re: Bug#374797: libpopt-dev: wrong libdir setting for amd64, causing rpath usage in dependent packages.
Date: Wed, 21 Jun 2006 19:33:45 +0100
[Message part 1 (text/plain, inline)]
Paul Martin wrote:
> On Wed, Jun 21, 2006 at 11:33:36AM +0100, Neil Williams wrote:
>> Package: libpopt-dev
>> Version: 1.10-2
>> Severity: important
>>
>> This reflects an earlier bug in libffi3:  #268152 - libpopt-dev includes
>> libpopt.la which refers to /usr/lib64 on amd64. This non-standard
>> directory then causes packages built against libpopt-dev on amd64 to
>> refer to /usr/lib64 via libtool and generate spurious --rpath usage.
>> Packages built this way then generate lintian and linda errors related
>> to --rpath usage in the resulting binaries. 
> 
> You can blame [expletive] autoconf for this one. Libraries built using 
> that prefer to use lib64 as the name of the libdir.
> 

I disagree. I'm building libqof1 on amd64 using autoconf and libqof.la
does not refer to lib64 in any way. The line in libpopt.la that is
referenced above contains usr/lib in libqof.la, built on amd64 using
autoconf. I haven't done anything special to avoid lib64 in this build -
which is why it was such a surprise to find it in packages that use
libpopt-dev.

I've got test packages if you want to check.

deb http://www.linux.codehelp.co.uk/ packages/unstable/$(ARCH)/
deb-src http://www.linux.codehelp.co.uk/ packages/unstable/source/

The *only* library on amd64 that refers to lib64 is libpopt-dev. You
cannot blame autoconf for that one.

-- 

Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#374797; Package libpopt-dev. Full text and rfc822 format available.

Acknowledgement sent to Paul Martin <pm@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #22 received at 374797@bugs.debian.org (full text, mbox):

From: Paul Martin <pm@debian.org>
To: Neil Williams <linux@codehelp.co.uk>
Cc: 374797@bugs.debian.org
Subject: Re: Bug#374797: libpopt-dev: wrong libdir setting for amd64, causing rpath usage in dependent packages.
Date: Thu, 22 Jun 2006 00:25:50 +0100
[Message part 1 (text/plain, inline)]
On Wed, Jun 21, 2006 at 07:33:45PM +0100, Neil Williams wrote:
> Paul Martin wrote:

> > You can blame [expletive] autoconf for this one. Libraries built using 
> > that prefer to use lib64 as the name of the libdir.
> 
> I disagree. I'm building libqof1 on amd64 using autoconf and libqof.la
> does not refer to lib64 in any way. The line in libpopt.la that is

We had a lot of fun and games with bug #370414.

I've found the root of the bug. The problem is this bit of configure.ac:

dnl XXX Choose /usr/lib or /usr/lib64 for library installs.
MARK64=
case "${target_cpu}" in
x86_64*|powerpc64*|ppc64*|sparc64*|s390x*)        MARK64=64 ;;
esac
AC_SUBST(MARK64)


-- 
Paul Martin <pm@debian.org>
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Paul Martin <pm@debian.org>:
Bug#374797; Package libpopt-dev. Full text and rfc822 format available.

Acknowledgement sent to Josselin Mouette <joss@debian.org>:
Extra info received and forwarded to list. Copy sent to Paul Martin <pm@debian.org>. Full text and rfc822 format available.

Message #27 received at 374797@bugs.debian.org (full text, mbox):

From: Josselin Mouette <joss@debian.org>
To: 374797@bugs.debian.org
Subject: libpopt.la's libdir
Date: Mon, 07 Aug 2006 00:05:33 +0200
[Message part 1 (text/plain, inline)]
Do you think you can upload a fix for this bug soon? Libtool adds a
rpath to /usr/lib64 for all packages depending on libpopt because of it.

Something like:
-usrlibdir = $(libdir)@MARK64@
+usrlibdir = $(libdir)
should fix the bug.
-- 
 .''`.           Josselin Mouette        /\./\
: :' :           josselin.mouette@ens-lyon.org
`. `'                        joss@debian.org
  `-  Debian GNU/Linux -- The power of freedom
[signature.asc (application/pgp-signature, inline)]

Reply sent to Paul Martin <pm@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Neil Williams <linux@codehelp.co.uk>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #32 received at 374797-close@bugs.debian.org (full text, mbox):

From: Paul Martin <pm@debian.org>
To: 374797-close@bugs.debian.org
Subject: Bug#374797: fixed in popt 1.10-3
Date: Mon, 07 Aug 2006 18:02:10 -0700
Source: popt
Source-Version: 1.10-3

We believe that the bug you reported is fixed in the latest version of
popt, which is due to be installed in the Debian FTP archive:

libpopt-dev_1.10-3_i386.deb
  to pool/main/p/popt/libpopt-dev_1.10-3_i386.deb
libpopt0-udeb_1.10-3_i386.udeb
  to pool/main/p/popt/libpopt0-udeb_1.10-3_i386.udeb
libpopt0_1.10-3_i386.deb
  to pool/main/p/popt/libpopt0_1.10-3_i386.deb
popt_1.10-3.diff.gz
  to pool/main/p/popt/popt_1.10-3.diff.gz
popt_1.10-3.dsc
  to pool/main/p/popt/popt_1.10-3.dsc



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 374797@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Paul Martin <pm@debian.org> (supplier of updated popt package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Tue,  8 Aug 2006 01:41:49 +0100
Source: popt
Binary: libpopt0-udeb libpopt-dev libpopt0
Architecture: source i386
Version: 1.10-3
Distribution: unstable
Urgency: low
Maintainer: Paul Martin <pm@debian.org>
Changed-By: Paul Martin <pm@debian.org>
Description: 
 libpopt-dev - lib for parsing cmdline parameters - development files
 libpopt0   - lib for parsing cmdline parameters
 libpopt0-udeb - lib for parsing cmdline parameters (udeb)
Closes: 374797
Changes: 
 popt (1.10-3) unstable; urgency=low
 .
   * The lib64 problem remains, as an rpath problem. Patch 374797.patch
     changes Makefile.in so that ./configure doesn't put the libraries in
     the wrong place or give them the wrong rpath. (Closes: #374797)
     PS. This fix is fragile to any of the autoconf files (eg.
     configure.ac or Makefile.ac) being touched or modified.
Files: 
 3f0a3e5183d0a0b89aef4a25a6713ffd 585 devel optional popt_1.10-3.dsc
 35c343b3b5d6f3e216ca3eee4715ad4d 27905 devel optional popt_1.10-3.diff.gz
 148016e4ef9c7bd9ac0cdef9fb91e7b2 33148 base important libpopt0_1.10-3_i386.deb
 ee16ea8fd44f9c2fca75436380872174 38130 libdevel optional libpopt-dev_1.10-3_i386.deb
 0b13feffdc1b1792591f78c2397ac23b 13972 debian-installer optional libpopt0-udeb_1.10-3_i386.udeb
Package-Type: udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.5 (GNU/Linux)

iD8DBQFE19+K+gi+rt7UWRIRAnx1AKCFFh4L+b2KbrQ8Bk/WEMiQSEXzFQCgh8US
oRkeAiqE/DudyLucqFhp+iw=
=WbmW
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 27 Jun 2007 07:59:20 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 00:11:53 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.